<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2002  ()
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Better login-box' for the 'newloginbox' extension.
 *
 * @author	 <>
 */


require_once(PATH_tslib."class.tslib_pibase.php");

class tx_newloginbox_pi1 extends tslib_pibase {
	var $prefixId = "tx_newloginbox_pi1";		// Same as class name
	var $scriptRelPath = "pi1/class.tx_newloginbox_pi1.php";	// Path to this script relative to the extension dir.
	var $extKey = "newloginbox";	// The extension key.
	
	
	/**
	 * Displays an alternative, more advanced / user friendly login form (than the default)
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_loadLL();

#debug($this->cObj->data);
		$d=$GLOBALS["TSFE"]->getStorageSiterootPids();
#		$content=t3lib_div::view_array($GLOBALS["TSFE"]->fe_user->user).t3lib_div::view_array($GLOBALS["HTTP_POST_VARS"]).t3lib_div::view_array($GLOBALS["HTTP_GET_VARS"]);
		
		
		$logintype=t3lib_div::GPvar("logintype");
		$redirect_url=t3lib_div::GPvar("redirect_url");
		
		if ($this->piVars["forgot"])	{
			$content.='<h3>'.$this->pi_getLL("forgot_password").'</h3>';
			if (trim($this->piVars["DATA"]["forgot_email"]) && t3lib_div::validEmail($this->piVars["DATA"]["forgot_email"]))	{
				$query="SELECT username,password FROM fe_users WHERE email='".addslashes(trim($this->piVars["DATA"]["forgot_email"]))."' 
					AND pid='".intval($d["_STORAGE_PID"])."'".
					$this->cObj->enableFields("fe_users");
				$res = mysql(TYPO3_db,$query);
				if ($row=mysql_fetch_assoc($res))	{
					$msg=sprintf($this->pi_getLL("forgot_password_pswmsg"),trim($this->piVars["DATA"]["forgot_email"]),$row["username"],$row["password"]);
				
				} else {
					$msg=sprintf($this->pi_getLL("forgot_password_no_pswmsg"),trim($this->piVars["DATA"]["forgot_email"]));
				}
				$this->cObj->sendNotifyEmail($msg, trim($this->piVars["DATA"]["forgot_email"]), "", $this->conf["email_from"], $this->conf["email_fromName"], $this->conf["replyTo"]);
#debug($row);
				
				$content.='<p>'.sprintf($this->pi_getLL("forgot_password_emailSent"), '<em>'.trim($this->piVars["DATA"]["forgot_email"]).'</em>').'</p>';
				$content.='<p'.$this->pi_classParam("back").'>'.$this->pi_linkTP_keepPIvars($this->pi_getLL("forgot_password_backToLogin"),array("forgot"=>"")).'</p>';
			} else {
				$content.='<p>'.$this->pi_getLL("forgot_password_enterEmail").'</p>';
				$content.='
					<table '.$this->conf["tableParams_details"].'>
					<form action="'.t3lib_div::getIndpEnv("REQUEST_URI").'" method="POST">
						<tr>
							<td><p>'.$this->pi_getLL("your_email").'</p></td>
							<td><input type="text" name="'.$this->prefixId.'[DATA][forgot_email]" value=""></td>
						</tr>
						<tr>
							<td></td>
							<td>
								<input type="Submit" name="submit" value="'.$this->pi_getLL("send_password").'"'.$this->pi_classParam("submit").'>
							</td>
						</tr>
					</form>
					</table>
				';
			}
		} else {
			if ($GLOBALS["TSFE"]->loginUser)	{
				if ($logintype=="login")	{
					$outH = $this->getOutputLabel("header_success");
					$outC = str_replace("###USER###",$GLOBALS["TSFE"]->fe_user->user["username"],$this->getOutputLabel("msg_success"));
	
					if ($outH)	$content.='<h3>'.$outH.'</h3>';
					if ($outC)	$content.='<p>'.$outC.'</p>';
					
					if (!$GLOBALS['TSFE']->fe_user->cookieId)	{
						$content.='<p style="color:red; font-weight:bold;">'.$this->pi_getLL("cookie_warning").'</p>';
					} elseif ($redirect_url)	{
						header("Location: ".t3lib_div::locationHeaderUrl($redirect_url));
						exit;
					}
				} else {
					$outH = $this->getOutputLabel("header_status");
					$outC = str_replace("###USER###",$GLOBALS["TSFE"]->fe_user->user["username"],$this->getOutputLabel("msg_status"));
	
					if ($outH)	$content.='<h3>'.$outH.'</h3>';
					if ($outC)	$content.='<p>'.$outC.'</p>';
					
					$usernameInfo = '<strong>'.$GLOBALS["TSFE"]->fe_user->user["username"].'</strong>, '.$GLOBALS["TSFE"]->fe_user->user["name"];
					if ($this->conf["detailsPage"])	{
						$usernameInfo = $this->pi_linkToPage($usernameInfo,$this->conf["detailsPage"],"",array("tx_newloginbox_pi3[showUid]" => $GLOBALS["TSFE"]->fe_user->user["uid"], "tx_newloginbox_pi3[returnUrl]"=>t3lib_div::getIndpEnv("REQUEST_URI")));
					}
					
					$content.='
						<table '.$this->conf["tableParams_details"].'>
						<form action="'.$this->pi_getPageLink($GLOBALS["TSFE"]->id,"_top").'" target="_top" method="POST">
							<tr>
								<td><p'.$this->pi_classParam("username").'>'.$this->pi_getLL("username").'</p></td>
								<td><p>'.$usernameInfo.'</p></td>
							</tr>
							<tr>
								<td></td>
								<td><input type="Submit" name="submit" value="'.$this->pi_getLL("logout").'"'.$this->pi_classParam("submit").'>
									<input type="hidden" name="logintype" value="logout">
									<input type="hidden" name="pid" value="'.intval($d["_STORAGE_PID"]).'">
								</td>
							</tr>
						</form>
						</table>
					';
				}
			} else {
				if ($logintype=="login")	{
					$outH = $this->getOutputLabel("header_error");
					$outC = $this->getOutputLabel("msg_error");
				} elseif ($logintype=="logout")	{
					$outH = $this->getOutputLabel("header_logout");
					$outC = $this->getOutputLabel("msg_logout");
				} else {	// No user currently logged in:
					$outH = $this->getOutputLabel("header_welcome");
					$outC = $this->getOutputLabel("msg_welcome");
				}
				if ($outH)	$content.='<h3>'.$outH.'</h3>';
				if ($outC)	$content.='<p>'.$outC.'</p>';
				$content.='
					<table '.$this->conf["tableParams_details"].'>
					<form action="'.$this->pi_getPageLink($GLOBALS["TSFE"]->id,"_top").'" target="_top" method="POST">
						<tr>
							<td><p>'.$this->pi_getLL("username").'</p></td>
							<td><input type="text" name="user" value=""></td>
						</tr>
						<tr>
							<td><p>'.$this->pi_getLL("password").'</p></td>
							<td><input type="password" name="pass" value=""></td>
						</tr>
						<tr>
							<td></td>
							<td><input type="Submit" name="submit" value="'.$this->pi_getLL("login").'"'.$this->pi_classParam("submit").'>
								<input type="hidden" name="logintype" value="login">
								<input type="hidden" name="pid" value="'.intval($d["_STORAGE_PID"]).'">
								<input type="hidden" name="redirect_url" value="'.htmlspecialchars($redirect_url).'">
							</td>
						</tr>
					</form>
					</table>
				';
				
				if ($this->cObj->data["tx_newloginbox_show_forgot_password"])	{
					$content.='<p'.$this->pi_classParam("forgotP").'>'.$this->pi_linkTP_keepPIvars($this->pi_getLL("forgot_password"),array("forgot"=>1)).'</p>';
				}
			}
		}

		return $this->pi_wrapInBaseClass($content);
	}
	
	/**
	 * Returns the headers/messages for the login/logout/status etc state of the login form. If a value is found int cObj->data[...] then that is used, otherwise the default from local_lang.
	 */
	function getOutputLabel($key)	{
		$dataF = nl2br(strip_tags($this->cObj->data["tx_".$this->extKey."_".$key],"<b><i><a>"));
		return $dataF ? $dataF : $this->pi_getLL("oLabel_".$key);
	}
}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/newloginbox/pi1/class.tx_newloginbox_pi1.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/newloginbox/pi1/class.tx_newloginbox_pi1.php"]);
}

?>